<!DOCTYPE html>
<html>
	<body>
		<p>Click the button to solve all 5 question</p>
		<button onclick="check_cycle()">check graph contain cycle or not</button>
		<p id="demo"></p>

		<script>
			function check_cycle() {
			
				class Graph {
				// defining vertex array and adjacent list
				constructor(noOfVertices) {
					this.noOfVertices = noOfVertices;
					this.AdjList = new Map();
				}
				
				//function to add the vertex
				addVertex(v) {
					// initialize the adjacent list with a null array
					this.AdjList.set(v, []);
				}
				
				// addEdge(v, w)
				addEdge(v, w) {
					// get the list for vertex v and put the vertex w denoting edge betweeen v and w since it is an 
					//directed graph
					this.AdjList.get(v).push(w);
				}
				
				// printGraph()
				printGraph() {
					// get all the vertices
					var get_keys = this.AdjList.keys();
					// iterate over the vertices
					for (var i of get_keys)
					{
						// great the corresponding adjacency list for the vertex
						var get_values = this.AdjList.get(i);
						var conc = "";
						// iterate over the adjacency list concatenate the values into a string
						for (var j of get_values)
							conc += j + " ";
						// print the vertex and its adjacency list
						console.log(i + " -> " + conc);
					}
				}
				
				
					isCyclicUtil(v, visited, recStack) {
						visited[v] = true;
						recStack[v] = true;
						//Recur for all neighbours if any neighbour is visited and in recStack then graph is cyclic 
						for(var neighbour of this.AdjList.get(v)) {
							if(visited[neighbour] == false) {
								if(this.isCyclicUtil(neighbour, visited, recStack) == true)
									return true;
							}
							else if (recStack[neighbour] == true) 
									return true;
						}
						//The node needs to be poped from recursion stack before function ends 
						recStack[v] = false;
						return false;
					}
					
					
					//Returns true if graph is cyclic else false 
					isCyclic() { 
						var all_element = this.AdjList.keys();
						var elements = this.AdjList.keys();
						for(var ele of all_element) {
							visited[ele] = false;
							recStack[ele] = false;
						}
						for(var node of elements) {
							if(visited[node] == false) 
								if(this.isCyclicUtil(node,visited,recStack) == true) 
									return true;
						}
						return false;
					}
			}
			// Using the above implemented graph class
			var g = new Graph(6);
			var vertices = [ 'A', 'B', 'C', 'D', 'E', 'F' ];
			
			// adding vertices
			for (var i = 0; i < vertices.length; i++) {
				g.addVertex(vertices[i]);
			}
			
			// adding edges
			g.addEdge('A', 'B');
			g.addEdge('A', 'D');
			g.addEdge('A', 'E');
			g.addEdge('B', 'C');
			g.addEdge('D', 'E');
			g.addEdge('F', 'E');
			g.addEdge('E', 'C');
			g.addEdge('C', 'F');
			//print the graph
			g.printGraph();
			
			var visited = {};
			var recStack = {};
			//call function to check cycle or not
			if(g.isCyclic())
				console.log("graph contain cycle");
			else
				console.log("graph does not contain cycle");
			
		}
		</script>

	</body>
</html>